This page is a short version of the <A href="http://java.sun.com/j2se/1.4.2/docs/api/java/util/regex/Pattern.html">regular expression</A> description for Java.

 <h4> Summary of regular-expression constructs </h4>

 <table border="0" cellpadding="1" cellspacing="0" 
  summary="Regular expression constructs, and what they match">

 <tr align="left">
 <th bgcolor="#CCCCFF" align="left" id="construct">Construct</th>
 <th bgcolor="#CCCCFF" align="left" id="matches">Matches</th>
 </tr>

 <tr><th>&nbsp;</th></tr>
 <tr align="left"><th colspan="2" id="characters">Characters</th></tr>

 <tr><td valign="top" headers="construct characters"><i>x</i></td>
     <td headers="matches">The character <i>x</i></td></tr>
 <tr><td valign="top" headers="construct characters"><tt>\\</tt></td>
     <td headers="matches">The backslash character</td></tr>
 <tr><td valign="top" headers="matches"><tt>\t</tt></td>
     <td headers="matches">The tab character (<tt>'&#92;u0009'</tt>)</td></tr>
 <tr><td valign="top" headers="construct characters"><tt>\n</tt></td>
     <td headers="matches">The newline (line feed) character (<tt>'&#92;u000A'</tt>)</td></tr>
 <tr><td valign="top" headers="construct characters"><tt>\r</tt></td>
     <td headers="matches">The carriage-return character (<tt>'&#92;u000D'</tt>)</td></tr>
 <tr><td valign="top" headers="construct characters"><tt>\f</tt></td>
     <td headers="matches">The form-feed character (<tt>'&#92;u000C'</tt>)</td></tr>
 <tr><td valign="top" headers="construct characters"><tt>\a</tt></td>
     <td headers="matches">The alert (bell) character (<tt>'&#92;u0007'</tt>)</td></tr>
 <tr><td valign="top" headers="construct characters"><tt>\e</tt></td>
     <td headers="matches">The escape character (<tt>'&#92;u001B'</tt>)</td></tr>
 <tr><td valign="top" headers="construct characters"><tt>\c</tt><i>x</i></td>
     <td headers="matches">The control character corresponding to <i>x</i></td></tr>

 <tr><th>&nbsp;</th></tr>
 <tr align="left"><th colspan="2" id="classes">Character classes</th></tr>

 <tr><td valign="top" headers="construct classes"><tt>[abc]</tt></td>
     <td headers="matches"><tt>a</tt>, <tt>b</tt>, or <tt>c</tt> (simple class)</td></tr>
 <tr><td valign="top" headers="construct classes"><tt>[^abc]</tt></td>
     <td headers="matches">Any character except <tt>a</tt>, <tt>b</tt>, or <tt>c</tt> (negation)</td></tr>
 <tr><td valign="top" headers="construct classes"><tt>[a-zA-Z]</tt></td>
     <td headers="matches"><tt>a</tt> through <tt>z</tt>
         or <tt>A</tt> through <tt>Z</tt>, inclusive (range)</td></tr>
 <tr><td valign="top" headers="construct classes"><tt>[a-d[m-p]]</tt></td>
     <td headers="matches"><tt>a</tt> through <tt>d</tt>,
      or <tt>m</tt> through <tt>p</tt>: <tt>[a-dm-p]</tt> (union)</td></tr>
 <tr><td valign="top" headers="construct classes"><tt>[a-z&&[def]]</tt></td>
     <td headers="matches"><tt>d</tt>, <tt>e</tt>, or <tt>f</tt> (intersection)</tr>
 <tr><td valign="top" headers="construct classes"><tt>[a-z&&[^bc]]</tt></td>
     <td headers="matches"><tt>a</tt> through <tt>z</tt>,
         except for <tt>b</tt> and <tt>c</tt>: <tt>[ad-z]</tt> (subtraction)</td></tr>
 <tr><td valign="top" headers="construct classes"><tt>[a-z&&[^m-p]]</tt></td>
     <td headers="matches"><tt>a</tt> through <tt>z</tt>,
          and not <tt>m</tt> through <tt>p</tt>: <tt>[a-lq-z]</tt>(subtraction)</td></tr>
 <tr><th>&nbsp;</th></tr>

 <tr align="left"><th colspan="2" id="predef">Predefined character classes</th></tr>

 <tr><td valign="top" headers="construct predef"><tt>.</tt></td>
     <td headers="matches">Any character (may or may not match line terminators)</td></tr>
 <tr><td valign="top" headers="construct predef"><tt>\d</tt></td>
     <td headers="matches">A digit: <tt>[0-9]</tt></td></tr>
 <tr><td valign="top" headers="construct predef"><tt>\D</tt></td>
     <td headers="matches">A non-digit: <tt>[^0-9]</tt></td></tr>
 <tr><td valign="top" headers="construct predef"><tt>\s</tt></td>
     <td headers="matches">A whitespace character: <tt>[ \t\n\x0B\f\r]</tt></td></tr>
 <tr><td valign="top" headers="construct predef"><tt>\S</tt></td>
     <td headers="matches">A non-whitespace character: <tt>[^\s]</tt></td></tr>
 <tr><td valign="top" headers="construct predef"><tt>\w</tt></td>
     <td headers="matches">A word character: <tt>[a-zA-Z_0-9]</tt></td></tr>
 <tr><td valign="top" headers="construct predef"><tt>\W</tt></td>
     <td headers="matches">A non-word character: <tt>[^\w]</tt></td></tr>

 <tr><th>&nbsp;</th></tr>
 <tr align="left"><th colspan="2" id="bounds">Boundary matchers</th></tr>

 <tr><td valign="top" headers="construct bounds"><tt>^</tt></td>
     <td headers="matches">The beginning of a line</td></tr>
 <tr><td valign="top" headers="construct bounds"><tt>$</tt></td>
     <td headers="matches">The end of a line</td></tr>
 <tr><td valign="top" headers="construct bounds"><tt>\b</tt></td>
     <td headers="matches">A word boundary</td></tr>

 <tr><th>&nbsp;</th></tr>
 <tr align="left"><th colspan="2" id="greedy">Greedy quantifiers</th></tr>

 <tr><td valign="top" headers="construct greedy"><i>X</i><tt>?</tt></td>
     <td headers="matches"><i>X</i>, once or not at all</td></tr>
 <tr><td valign="top" headers="construct greedy"><i>X</i><tt>*</tt></td>
     <td headers="matches"><i>X</i>, zero or more times</td></tr>
 <tr><td valign="top" headers="construct greedy"><i>X</i><tt>+</tt></td>
     <td headers="matches"><i>X</i>, one or more times</td></tr>
 <tr><td valign="top" headers="construct greedy"><i>X</i><tt>{</tt><i>n</i><tt>}</tt></td>
     <td headers="matches"><i>X</i>, exactly <i>n</i> times</td></tr>
 <tr><td valign="top" headers="construct greedy"><i>X</i><tt>{</tt><i>n</i><tt>,}</tt></td>
     <td headers="matches"><i>X</i>, at least <i>n</i> times</td></tr>
 <tr><td valign="top" headers="construct greedy"><i>X</i><tt>{</tt><i>n</i><tt>,</tt><i>m</i><tt>}</tt></td>
     <td headers="matches"><i>X</i>, at least <i>n</i> but not more than <i>m</i> times</td></tr>

 <tr><th>&nbsp;</th></tr>
 <tr align="left"><th colspan="2" id="logical">Logical operators</th></tr>

 <tr><td valign="top" headers="construct logical"><i>XY</i></td>
     <td headers="matches"><i>X</i> followed by <i>Y</i></td></tr>
 <tr><td valign="top" headers="construct logical"><i>X</i><tt>|</tt><i>Y</i></td>
     <td headers="matches">Either <i>X</i> or <i>Y</i></td></tr>
 <tr><td valign="top" headers="construct logical"><tt>(</tt><i>X</i><tt>)</tt></td>
     <td headers="matches">X, as a capturing group</td></tr>

 </table>

 <hr>


 <h4> Backslashes, escapes, and quoting </h4>

 <p> The backslash character (<tt>'\'</tt>) serves to introduce escaped
 constructs, as defined in the table above, as well as to quote characters
 that otherwise would be interpreted as unescaped constructs.  Thus the
 expression <tt>\\</tt> matches a single backslash and <tt>\{</tt> matches a
 left brace.

 <p> It is an error to use a backslash prior to any alphabetic character that
 does not denote an escaped construct; these are reserved for future
 extensions to the regular-expression language.  A backslash may be used
 prior to a non-alphabetic character regardless of whether that character is
 part of an unescaped construct.

 <h4> Character Classes </h4>

    <p> Character classes may appear within other character classes, and
    may be composed by the union operator (implicit) and the intersection
    operator (<tt>&amp;&amp;</tt>).
    The union operator denotes a class that contains every character that is
    in at least one of its operand classes.  The intersection operator
    denotes a class that contains every character that is in both of its
    operand classes.

    <p> The precedence of character-class operators is as follows, from
    highest to lowest:

    <blockquote><table border="0" cellpadding="1" cellspacing="0" 
                 summary="Precedence of character class operators.">
      <tr><th>1&nbsp;&nbsp;&nbsp;&nbsp;</th>
	  <td>Literal escape&nbsp;&nbsp;&nbsp;&nbsp;</td>
	  <td><tt>\x</tt></td></tr>
     <tr><th>2&nbsp;&nbsp;&nbsp;&nbsp;</th>
	  <td>Grouping</td>
	  <td><tt>[...]</tt></td></tr>
     <tr><th>3&nbsp;&nbsp;&nbsp;&nbsp;</th>
	  <td>Range</td>
	  <td><tt>a-z</tt></td></tr>
      <tr><th>4&nbsp;&nbsp;&nbsp;&nbsp;</th>
	  <td>Union</td>
	  <td><tt>[a-e][i-u]<tt></td></tr>
      <tr><th>5&nbsp;&nbsp;&nbsp;&nbsp;</th>
	  <td>Intersection</td>
	  <td><tt>[a-z&&[aeiou]]</tt></td></tr>
    </table></blockquote>

    <p> Note that a different set of metacharacters are in effect inside
    a character class than outside a character class. For instance, the
    regular expression <tt>.</tt> loses its special meaning inside a
    character class, while the expression <tt>-</tt> becomes a range
    forming metacharacter.
