#!/bin/bash
#
# Database.sh - Command-line wrapper for org.glite.security.voms.database.setup.Database.
#
# Usage: Database.sh VONAME (create|drop)
#
# Author: Karoly Lorentey <lorentey@elte.hu>
#

if [ $# -lt 2 ]; then
    echo "Usage: $0 VONAME (create|drop|add-global-admin)" >&2
    exit 1
fi

if [ -z "$JAVA_HOME" ]; then
    echo "Error: JAVA_HOME is not set" >&2
    exit 1
fi

if [ -z "$GLITE_LOCATION_VAR" ]; then
    echo "Error: GLITE_LOCATION_VAR is not set" >&2
    exit 1
fi

voname="$1"
shift

if [ -z "$CLASSPATH" ]; then
    cp="$CLASSPATH:"
else
    cp=""
fi

cp="$cp$GLITE_LOCATION/share/java/glite-security-voms-admin-server.jar:$GLITE_LOCATION/share/voms-admin/classes"

for jar in "$GLITE_LOCATION"/share/voms-admin/lib/*.jar; do 
    cp="$cp:$jar"
done

exec "$JAVA_HOME"/bin/java \
    -classpath "$cp" \
    -Dvoms.vo.name="$voname" \
    -Dvoms.configuration.directory="$GLITE_LOCATION_VAR/etc/voms-admin/$voname" \
    -DGLITE_LOCATION="$GLITE_LOCATION" \
    -DGLITE_LOCATION_VAR="$GLITE_LOCATION_VAR" \
    -DGLITE_LOCATION_LOG="$GLITE_LOCATION_LOG" \
    -DGLITE_LOCATION_TMP="$GLITE_LOCATION_TMP" \
    org.glite.security.voms.database.Database \
    "$@"

# Please do not change this line.
# arch-tag: 35f3c6d1-b428-40e2-b28a-6038d729fc7f
